/*
 * Copyright (c) 2013-2016 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.store.enums.scheduler.quartz.CalendarIntervalTriggerRepeatIntervalUnitStore', {
  extend : 'Ext.data.Store',

  requires : [
    'QDesk.enums.scheduler.quartz.RepeatIntervalUnit',
    'QDesk.util.quartz.QuartzEnumUtils'
  ],

  fields : ['value', 'valueLabel'],

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.schedulerVersion )
      Ext.Error.raise( 'Required config parameter missing: qdesk.schedulerVersion' );

    var data = [];

    // Commented out as triggers with ms repeat interval unit never fire (they actually produce a NPE in Quartz). Second
    // is the lowest usable repeat interval unit value.
    //
    //if ( config.qdesk.schedulerVersion.major >= 2 )
    //{
    //  data.push( {
    //    /* Quartz >= 2.0.0 */
    //    value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MILLISECOND,
    //    valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MILLISECOND )
    //  } );
    //}

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.SECOND,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.SECOND )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MINUTE,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MINUTE )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.HOUR,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.HOUR )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.DAY,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.DAY )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.WEEK,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.WEEK )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MONTH,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.MONTH )
    } );

    data.push( {
      value : QDesk.enums.scheduler.quartz.RepeatIntervalUnit.YEAR,
      valueLabel : QDesk.util.quartz.QuartzEnumUtils.getRepeatIntervalUnitName( QDesk.enums.scheduler.quartz.RepeatIntervalUnit.YEAR )
    } );

    Ext.apply( config, {
      data : data
    } );

    me.callParent( [config] );
  }
} );