/*
 * Copyright (c) 2013-2016 QuartzDesk.com. All Rights Reserved.
 * QuartzDesk.com PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

Ext.define( 'QDesk.view.main.scheduler.quartz.triggers.ViewNextFireTimesWindow', {
  extend : 'Ext.window.Window',

  requires : [
    'QDesk.Msg',
    'QDesk.view.main.scheduler.quartz.triggers.ViewNextFireTimesGrid'
  ],

  alias : 'widget.QuartzViewNextFireTimesWindow',

  cls : 'quartzViewNextFireTimesWindow',
  iconCls : 'quartzViewNextFireTimesWindowIcon',

  scrollable : true,

  modal : true,
  resizable : true,
  maximizable : true,

  width : 500,
  height : 500,

  minWidth : 300,
  minHeight : 300,

  layout : 'fit',

  qdesk : {
    /*
     * Required ID of the scheduler connection.
     */
    connectionId : undefined,

    /*
     * Optional trigger name.
     */
    triggerName : undefined
  },

  constructor : function ( config )
  {
    var me = this;

    config = config || {};

    if ( !config.qdesk )
      Ext.Error.raise( 'Required config parameter missing: qdesk' );

    if ( !config.qdesk.connectionId )
      Ext.Error.raise( 'Required config parameter missing: qdesk.connectionId' );

    var title = config.qdesk.triggerName ?
        QDesk.Msg.get( 'QDesk.view.main.scheduler.quartz.triggers.ViewNextFireTimesWindow.titleWithTriggerName',
            config.qdesk.triggerName ) :
        QDesk.Msg.get( 'QDesk.view.main.scheduler.quartz.triggers.ViewNextFireTimesWindow.titleNoTriggerName' );

    Ext.apply( config, {
      title : title,
      items : [
        {
          xtype : 'QuartzViewNextFireTimesGrid',
          itemId : 'quartzViewNextFireTimesGrid',
          qdesk : config.qdesk
        }
      ],

      dockedItems : [
        {
          xtype : 'toolbar',
          dock : 'bottom',
          ui : 'footer',
          defaults : {
            minWidth : 75
          },
          items : [
            {
              xtype : 'component',
              flex : 1
            },
            {
              xtype : 'button',
              itemId : 'closeButton',
              text : QDesk.Msg.get( 'QDesk.buttonLabelClose' )
            }
          ]
        }
      ]
    } );

    me.callParent( [ config ] );

    me.down( '#closeButton' ).on( 'click', function ()
    {
      me.close();
    } );
  }
} );